<template>
    <h4> Transferencia: {{ props.transferenciaCabecera.d_tipo_transf }} </h4>
    <h6> Total: $ {{ formatPrice(props.transferenciaCabecera.importe) }} </h6>
    <table class="table table-striped" v-if="data.DetalleCabecera.length > 0">
        <thead>
            <tr>
                <th scope="col">Periodo</th>
                <th scope="col">Importe</th>
            </tr>
        </thead>
        <tbody>
            <tr v-for="transf in data.DetalleCabecera" :key="transf.id_tabla_sol">
                <td v-text="formatDate(transf.fecha_cupo)"></td>
                <td v-text="formatPrice(transf.importe_mes)"></td>
            </tr>
        </tbody>
    </table>
    <div v-else class="alert alert-secondary" role="alert">
        No hay elementos para mostrar
    </div>
</template>
  
<script setup lang="ts">
//librerias
import { onMounted, reactive } from "vue";
import http from "@/http";
import type { AxiosResponse } from "axios";
import { urlApi, loading } from "@/shared.js";
import { DateTime } from "luxon";
//entities
import Cupos from "@/entities/Cupos/Cupo";

var data = reactive({
    DetalleCabecera: [] as Cupos[],

});

const props = defineProps({
    transferenciaCabecera: { type: Cupos, required: true }
});

function formatDate(date: string | null) {
    if (date != null) {
        return DateTime.fromISO(date).toLocaleString();
    }
}

function formatPrice(value: any) {
    let val = (value / 1).toFixed(2).replace('.', ',')
    return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".")
}

onMounted(async () => {
    loading.show();
    const paramsRequest: any = {};
    paramsRequest.id_cupo_movimiento_cabecera = props.transferenciaCabecera.id_cupo_movimiento_cabecera;
    const response: AxiosResponse<Cupos[]> = await http.request<Cupos[]>({
        method: "GET",
        url: urlApi + "getCuposMovimientos",
        params: paramsRequest,
        transformResponse: [
            (data: string) => {
                const cupos: Cupos[] = JSON.parse(data);
                const dataAux: Cupos[] = [];
                cupos.forEach((element: Cupos) => {
                    dataAux.push(Object.assign(new Cupos(), element));
                });
                return dataAux;
            },
        ],
    });
    data.DetalleCabecera = response.data;
    loading.hide();
})

</script>
  